package com.example.nto.service.impl;

import com.example.nto.entity.Code;
import com.example.nto.entity.Employee;
import com.example.nto.repository.CodeRepository;
import com.example.nto.service.EmployeeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.util.Optional;

@Service
public class EmployeeServiceImpl implements EmployeeService {
    @Autowired
    private com.example.nto.repository.EmployeeRepository EmployeeRepository;
    @Autowired
    private CodeRepository codeRepository;

    @Override
    public Optional<Employee> findByLogin(String login) {
        return EmployeeRepository.findByLogin(login);
    }

    @Override
    public Optional<Code> findCodeById(Long id) {
        return Optional.of(codeRepository.getById(id));
    }

    @Override
    public void setLastVisitEmployee(long Id, LocalDateTime lastVisit) {
        Employee employee = EmployeeRepository.getById(Id);
        employee.setLastVisit(lastVisit);
        EmployeeRepository.save(employee);
    }

    @Override
    public boolean existsByLogin(String login) {
        return EmployeeRepository.existsByLogin(login);
    }

    @Override
    public Code setCodeEmployee(long Id, long code) {
        Code newCode = new Code(Id, code);
        codeRepository.save(newCode);
        return newCode;
    }
}